## cmtk 3.0.0

=== CMakeLists.txt ===
##
##  Copyright 1997-2010 Torsten Rohlfing
##
##  Copyright 2004-2014 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 5127 $
##
##  $LastChangedDate: 2014-01-09 12:41:41 -0800 (Thu, 09 Jan 2014) $
##
##  $LastChangedBy: torstenrohlfing $
##

##
## This file used to borrow heavily from the analogous InsightToolkit file.
## It may have evolved away since then, however.
##

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0)
SET(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required

IF(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW) ## libraries with full paths vs. search paths
ENDIF(COMMAND cmake_policy)
SET(CMAKE_OVERRIDE_COMPILER_MISMATCH 1)

PROJECT(CMTK)
SET(CMTK_VERSION_MAJOR "3")
SET(CMTK_VERSION_MINOR "0")
SET(CMTK_VERSION_PATCH "0")

SET(CMTK_VERSION_STRING "${CMTK_VERSION_MAJOR}.${CMTK_VERSION_MINOR}.${CMTK_VERSION_PATCH}")

#-----------------------------------------------------------------------------
# Test for some required system information.
INCLUDE (${CMAKE_ROOT}/Modules/CMakeDetermineSystem.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityC.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityCXX.cmake)

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/CMake)

#-----------------------------------------------------------------------------
# On Mac, if we have MacPorts installed, we need to look for libraries in 
# /opt/local.

MESSAGE(STATUS "System is " ${CMAKE_SYSTEM})
IF(CMAKE_SYSTEM MATCHES "Darwin.*")
  IF(EXISTS /opt/local)
    LIST(INSERT CMAKE_PREFIX_PATH 0 "/opt/local")
  ENDIF(EXISTS /opt/local)
ENDIF(CMAKE_SYSTEM MATCHES "Darwin.*")

#-----------------------------------------------------------------------------
# Output directories.
IF(NOT LIBRARY_OUTPUT_PATH)
  SET (LIBRARY_OUTPUT_PATH ${CMTK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all libraries.")
ENDIF(NOT LIBRARY_OUTPUT_PATH)
IF(NOT EXECUTABLE_OUTPUT_PATH)
  SET (EXECUTABLE_OUTPUT_PATH ${CMTK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
ENDIF(NOT EXECUTABLE_OUTPUT_PATH)
MARK_AS_ADVANCED(LIBRARY_OUTPUT_PATH EXECUTABLE_OUTPUT_PATH)
IF(NOT CMTK_BUILD_LIB_DIR) # variable used for generating CMTKConfig.cmake for the build tree
  SET(CMTK_BUILD_LIB_DIR "/bin")
ENDIF(NOT CMTK_BUILD_LIB_DIR)

SET(CMTK_LIBRARY_PATH "${LIBRARY_OUTPUT_PATH}")
SET(CMTK_EXECUTABLE_PATH "${EXECUTABLE_OUTPUT_PATH}")
SET(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

# set CMTK_DIR so it can be used by subprojects
SET(CMTK_DIR "${CMAKE_BINARY_DIR}" CACHE INTERNAL "CMTK dir to be used by subprojects")

#-----------------------------------------------------------------------------
# Setup install target directories
IF(NOT CMTK_INSTALL_BIN_DIR)
  SET(CMTK_INSTALL_BIN_DIR bin CACHE PATH "Binary files will be installed here")
ENDIF(NOT CMTK_INSTALL_BIN_DIR)

IF(NOT CMTK_INSTALL_LIB_DIR)
  # 64 bit libraries are not installed in the same directories on solaris
  # Ref: http://docs.sun.com/app/docs/doc/816-5138/6mba6ua5m?a=view
  SET(sun64 )
  IF(CMAKE_SYSTEM MATCHES "SunOS.*" AND CMAKE_SIZEOF_VOID_P EQUAL 8)
    EXEC_PROGRAM("uname"
      ARGS "-p"
      OUTPUT_VARIABLE sunproc
    )
    IF("${sunproc}" STREQUAL "sparc")
      SET(sun64 "/sparcv9")
    ENDIF("${sunproc}" STREQUAL "sparc")

    IF("${sunproc}" STREQUAL "i386")
      SET(sun64 "/amd64")
    ENDIF("${sunproc}" STREQUAL "i386")

    IF("${sun64}" STREQUAL "")
      # sun64 is not set - solaris has been ported to a new architecture?
      MESSAGE("Warning: Unknown processor '${sunproc}'. The libraries may not be installed in the right place.")
    ENDIF("${sun64}" STREQUAL "")
  ENDIF(CMAKE_SYSTEM MATCHES "SunOS.*" AND CMAKE_SIZEOF_VOID_P EQUAL 8)

  SET(CMTK_INSTALL_LIB_DIR "lib${sun64}/cmtk" CACHE PATH "Library files will be installed here")
ENDIF(NOT CMTK_INSTALL_LIB_DIR)

IF(NOT CMTK_INSTALL_DATA_DIR)
  SET(CMTK_INSTALL_DATA_DIR "share/cmtk" CACHE PATH "Data files will be installed here")
ENDIF(NOT CMTK_INSTALL_DATA_DIR)

IF(NOT CMTK_INSTALL_INCLUDE_DIR)
  SET(CMTK_INSTALL_INCLUDE_DIR "include/cmtk" CACHE PATH "Include files will be installed here")
ENDIF(NOT CMTK_INSTALL_INCLUDE_DIR)

#-----------------------------------------------------------------------------
# Check for system headers.
INCLUDE (CheckIncludeFiles)
CHECK_INCLUDE_FILES (dirent.h HAVE_DIRENT_H)
CHECK_INCLUDE_FILES (execinfo.h HAVE_EXECINFO_H)
CHECK_INCLUDE_FILES (fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILES (ieeefp.h HAVE_IEEEFP_H)
CHECK_INCLUDE_FILES (inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES (malloc.h HAVE_MALLOC_H)
CHECK_INCLUDE_FILES (pthread.h HAVE_PTHREAD_H)
CHECK_INCLUDE_FILES (stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILES (termios.h HAVE_TERMIOS_H)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (values.h HAVE_VALUES_H)

CHECK_INCLUDE_FILES (sys/ioctl.h HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILES (sys/procfs.h HAVE_SYS_PROCFS_H)
CHECK_INCLUDE_FILES (sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES (sys/time.h HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILES (sys/times.h HAVE_SYS_TIMES_H)
CHECK_INCLUDE_FILES (sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILES (sys/utsname.h HAVE_SYS_UTSNAME_H)

IF(HAVE_SYS_STAT_H)
  SET(CMAKE_EXTRA_INCLUDE_FILES sys/stat.h)
ENDIF(HAVE_SYS_STAT_H)
CHECK_TYPE_SIZE("((struct stat*)0)->st_mode" SIZEOF_ST_SIZE)
IF(SIZEOF_ST_SIZE EQUAL 4)
  CHECK_TYPE_SIZE("struct stat64" CMTK_USE_STAT64)
ENDIF(SIZEOF_ST_SIZE EQUAL 4)
SET(CMAKE_EXTRA_INCLUDE_FILES)

INCLUDE(TestBigEndian)
TEST_BIG_ENDIAN(WORDS_BIGENDIAN)

#-----------------------------------------------------------------------------
# Test NaN high bit
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/TestQnanhibit.cmake)
TEST_QNANHIBIT(QNANHIBIT_VALUE ${CMAKE_CURRENT_SOURCE_DIR}/CMake)
IF(QNANHIBIT_VALUE)
  SET(QNANHIBIT 1 CACHE INTERNAL "The 22nd bit of 32-bit floating-point quiet NaN.")
ELSE(QNANHIBIT_VALUE)
  SET(QNANHIBIT 0 CACHE INTERNAL "The 22nd bit of 32-bit floating-point quiet NaN.")
ENDIF(QNANHIBIT_VALUE)

#-----------------------------------------------------------------------------
# Check for at least one of the typical STL hash map implementations

INCLUDE (CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX(unordered_map HAVE_UNORDERED_MAP)
IF(NOT HAVE_UNORDERED_MAP)
  CHECK_INCLUDE_FILE_CXX(hash_map HAVE_HASH_MAP)
  IF(NOT HAVE_HASH_MAP)
    CHECK_INCLUDE_FILE_CXX(hash_map.h HAVE_HASH_MAP_H)
  ENDIF(NOT HAVE_HASH_MAP)
ENDIF(NOT HAVE_UNORDERED_MAP)

# set a single flag is we have ANY hash map implementation in STL
SET(HAVE_STL_HASH_MAP ${HAVE_UNORDERED_MAP}${HAVE_HASH_MAP}${HAVE_HASH_MAP_H} CACHE INTERNAL "Flag for presence of ANY hash map implementation in the C++ STL")

#-----------------------------------------------------------------------------
# build configuration options.
OPTION(BUILD_SHARED_LIBS "Build CMTK with shared libraries." OFF)
SET(CMTK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

OPTION(CMTK_BUILD_WRAPPER "Build 'cmtk' wrapper script and install all actual executables in a private directory to avoid name collisions" ON)
MARK_AS_ADVANCED(CMTK_BUILD_WRAPPER)

OPTION(CMTK_BUILD_UNSTABLE "Build 'unstable' library and tools" OFF)
MARK_AS_ADVANCED(CMTK_BUILD_UNSTABLE)

OPTION(CMTK_BUILD_STACKTRACE "Build tools with stack trace printing in case of crash (increases build time)" ON)
MARK_AS_ADVANCED(CMTK_BUILD_STACKTRACE)

OPTION(CMTK_BUILD_DEMO "Build demonstration code. Strange things will happen if you turn this on." OFF)
MARK_AS_ADVANCED(CMTK_BUILD_DEMO)
IF(CMTK_BUILD_DEMO)
  MESSAGE( WARNING "Demo mode is enabled. Make sure not to use this build for production use!")
ENDIF(CMTK_BUILD_DEMO)

#-----------------------------------------------------------------------------
# Add an option to use or not to use SMP multi-core parallelism

OPTION(CMTK_USE_SMP "Enable shared-memory parallelism (requires at least POSIX Threads, OpenMP, or Windows threads)" ON)

#-----------------------------------------------------------------------------
# Add an option to enable or disable POSIX threads if pthread.h header exists

IF(HAVE_PTHREAD_H)
  OPTION(CMTK_USE_PTHREADS "Use POSIX Threads for SMP parallelism" ON)
  MARK_AS_ADVANCED(CMTK_USE_PTHREADS)

  IF(NOT CMTK_USE_SMP)
    SET(CMTK_USE_PTHREADS OFF)
  ENDIF(NOT CMTK_USE_SMP)
ENDIF(HAVE_PTHREAD_H)

#-----------------------------------------------------------------------------
# for the gnu compiler a -D_PTHREADS is needed on sun
# for the native compiler a -mt flag is needed on the sun
IF(CMTK_USE_PTHREADS)

  IF(${CMAKE_SYSTEM} MATCHES "SunOS.*")
    IF(CMAKE_COMPILER_IS_GNUCXX)
      SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -D_PTHREADS")
    ELSE(CMAKE_COMPILER_IS_GNUCXX)
      SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -mt")
      SET(CMTK_REQUIRED_C_FLAGS "${CMTK_REQUIRED_C_FLAGS} -mt")
    ENDIF(CMAKE_COMPILER_IS_GNUCXX)
  ENDIF(${CMAKE_SYSTEM} MATCHES "SunOS.*")
ENDIF(CMTK_USE_PTHREADS)

# mingw thread support
IF(MINGW)
  SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} -mthreads")
  SET(CMTK_REQUIRED_C_FLAGS "${CMTK_REQUIRED_C_FLAGS} -mthreads")
  SET(CMTK_REQUIRED_LINK_FLAGS "${CMTK_REQUIRED_LINK_FLAGS} -mthreads")
ENDIF(MINGW)

#-----------------------------------------------------------------------------
# Check for, and configure, OpenMP

IF(NOT DEFINED CMTK_USE_OPENMP)
  FIND_PACKAGE(OpenMP)
  IF(OPENMP_FOUND)
    OPTION(CMTK_USE_OPENMP "Use OpenMP for SMP parallelism" ON)
    MARK_AS_ADVANCED(CMTK_USE_OPENMP)
    
    IF(NOT CMTK_USE_SMP)
      SET(CMTK_USE_OPENMP OFF)
    ENDIF(NOT CMTK_USE_SMP)
  ENDIF(OPENMP_FOUND)
ENDIF(NOT DEFINED CMTK_USE_OPENMP)

IF(CMTK_USE_OPENMP)
  SET(CMTK_REQUIRED_CXX_FLAGS "${CMTK_REQUIRED_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
  SET(CMTK_REQUIRED_LINK_FLAGS "${CMTK_REQUIRED_LINK_FLAGS} ${OpenMP_C_FLAGS}")
ENDIF(CMTK_USE_OPENMP)

#-----------------------------------------------------------------------------
# Check for, and configure, Grand Central Dispatch

CHECK_INCLUDE_FILES(dispatch/dispatch.h HAVE_DISPATCH_H)
IF(HAVE_DISPATCH_H)
  OPTION(CMTK_USE_GCD "Use Grand Central Dispatch for SMP parallelism with system-level load balancing" ON)
  
  IF(NOT CMTK_USE_SMP)
    SET(CMTK_USE_GCD OFF)
  ENDIF(NOT CMTK_USE_SMP)
  
  IF(CMTK_USE_GCD)
  ENDIF(CMTK_USE_GCD)
ENDIF(HAVE_DISPATCH_H)

#-----------------------------------------------------------------------------
# Check for, and configure, CUDA

OPTION(CMTK_USE_CUDA "Use CUDA for GPU computing" OFF)

IF(CMTK_USE_CUDA)
  # check using cmake's own FindCUDA above v2.8 or use our own for earlier versions
  IF (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 2.8)
    INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/FindCUDA.cmake)
  ELSE (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 2.8)
    FIND_PACKAGE(CUDA)
  ENDIF(${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} STRLESS 2.8)
 
ENDIF(CMTK_USE_CUDA)

#-----------------------------------------------------------------------------
# Check whether compiler supports variable-size automatic arrays, i.e.,
# things like "const int size = 10; const char string[size];" rather than
# "const char string[10];"

INCLUDE(${CMAKE_ROOT}/Modules/CheckCXXSourceCompiles.cmake)

=== Utilities/CMakeLists.txt ===
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  Copyright 2004-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 3631 $
##
##  $LastChangedDate: 2011-12-16 13:58:51 -0800 (Fri, 16 Dec 2011) $
##
##  $LastChangedBy: torstenrohlfing $
##

# turn off Windows security warnings for bundled code
IF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS)
ENDIF(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

IF(CMTK_BUILD_ZLIB)
  SUBDIRS(zlib)
ENDIF(CMTK_BUILD_ZLIB)

IF(CMTK_BUILD_NRRD)
  SUBDIRS(NrrdIO)
ENDIF(CMTK_BUILD_NRRD)

IF(CMTK_BUILD_DCMTK)
  SUBDIRS(dcmtk)
ENDIF(CMTK_BUILD_DCMTK)

IF(CMTK_BUILD_MXML)
  SUBDIRS(mxml)
ENDIF(CMTK_BUILD_MXML)

IF(CMTK_BUILD_SQLITE)
  SUBDIRS(sqlite3)
ENDIF(CMTK_BUILD_SQLITE)

#
# If building test code, we need numdiff to tolerantly compare numerical results against baselines
#
IF(BUILD_TESTING)
  # Tets whether numdiff is already available
  FIND_PROGRAM(NUMDIFF_EXECUTABLE_SYSTEM numdiff PATHS /usr/bin /usr/local/bin /opt/local/bin ENV PATH)
  # If not available, build our own
  IF(EXISTS ${NUMDIFF_EXECUTABLE_SYSTEM})
    MESSAGE(STATUS "Found numdiff executable at ${NUMDIFF_EXECUTABLE_SYSTEM}")
    SET(NUMDIFF_EXECUTABLE ${NUMDIFF_EXECUTABLE_SYSTEM} CACHE PATH "Path to numdiff executable" FORCE)
  ELSE(EXISTS ${NUMDIFF_EXECUTABLE_SYSTEM})
    MESSAGE(STATUS "BUILD_TESTING is active - building numdiff for tolerant numerical comparisons")
    SUBDIRS(numdiff-5.2.1)
    SET(NUMDIFF_EXECUTABLE ${CMAKE_BINARY_DIR}/bin/numdiff CACHE PATH "Path to numdiff executable" FORCE)
  ENDIF(EXISTS ${NUMDIFF_EXECUTABLE_SYSTEM})
  MARK_AS_ADVANCED(NUMDIFF_EXECUTABLE NUMDIFF_EXECUTABLE_SYSTEM)
ENDIF(BUILD_TESTING)

=== apps/CMakeLists.txt ===
##
##  Copyright 1997-2012 Torsten Rohlfing
##
##  Copyright 2004-2013 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 5087 $
##
##  $LastChangedDate: 2013-12-03 15:33:18 -0800 (Tue, 03 Dec 2013) $
##
##  $LastChangedBy: torstenrohlfing $
##

SET(CMTK_LIBRARIES "cmtkSegmentation;cmtkRecon;cmtkRegistration;cmtkIO;cmtkBase;cmtkNumerics;cmtkSystem")
IF(CMTK_BUILD_UNSTABLE)
  SET(CMTK_LIBRARIES "cmtkUnstable;${CMTK_LIBRARIES}")
ENDIF(CMTK_BUILD_UNSTABLE)

SET(APPS avg_adm
  describe
  groupwise_init
  groupwise_affine
  groupwise_warp
  asegment
  average_affine
  average_images
  average_labels
  concat_affine
  convertx
  convert_warp
  destripe
  dof2mat
  dwi_mask_bad_slices
  epiunwarp
  fibxform
  fib2image
  film
  filter
  fit_affine_dfield
  fit_affine_xform
  fit_affine_xform_landmarks
  fit_spline_dfield
  fit_spline_xform
  glm
  gmm
  gregxform
  hausdorff
  histogram
  imagemath
  interleaved_bad_slices
  jidb
  levelset
  lsba
  lmsba
  lvote
  make_initial_affine
  mat2dof
  mk_adni_phantom
  mk_analyze_hdr
  mk_nifti_hdr
  mk_phantom_3d
  mrbias
  overlap
  probe
  pxsearch
  reformatx
  registration
  registrationx
  regress
  reorient
  sba
  sbai
  sequence
  sh_command_line_parser
  similarity
  split
  statistics
  stream_pixels
  streamxform
  sympl
  symplx
  ttest
  unsplit
  unwarp_image_phantom
  vol2csv
  volume_injection
  volume_reconstruction
  vtkxform
  warp
  warpx
  warp2ps
  xform2dfield
  xform2itk
  xform2scalar)

IF(CMTK_USE_CUDA)
  SET(CUDA_APPS 
    levelset_cuda
    mrbias_cuda
    symplx_cuda)
ENDIF(CMTK_USE_CUDA)

IF(CMTK_USE_SQLITE)
  LIST(APPEND APPS dbtool)
ENDIF(CMTK_USE_SQLITE)

IF(CMTK_ROOT_PATH_SRI24)
  LIST(APPEND APPS asegment_sri24)
ENDIF(CMTK_ROOT_PATH_SRI24)

IF(HAVE_STL_HASH_MAP)
  LIST(APPEND APPS mcaffine mcwarp)
ENDIF(HAVE_STL_HASH_MAP)

IF(CMTK_USE_DCMTK)
  LIST(APPEND APPS dcm2image)
ENDIF(CMTK_USE_DCMTK)

IF(CMTK_USE_FFTW_FOUND)
  LIST(APPEND APPS
    detect_spheres_matched_filter
    detect_adni_phantom)
ENDIF(CMTK_USE_FFTW_FOUND)

FOREACH(APPLICATION ${APPS})
  ADD_EXECUTABLE(${APPLICATION} ${APPLICATION}.cxx)
  TARGET_LINK_LIBRARIES(${APPLICATION} ${CMTK_LIBRARIES} ${CMTK_SYSTEM_LIBRARIES})

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
    SET(manpage cmtk-${APPLICATION}.1)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
    SET(manpage ${APPLICATION}.1)
  ENDIF(CMTK_BUILD_WRAPPER)
  
  IF(BUILD_MANPAGES)
    ADD_CUSTOM_COMMAND(
      OUTPUT ${manpage}
      COMMAND ${APPLICATION} --man ">" ${manpage}
      DEPENDS ${APPLICATION})
    ADD_CUSTOM_TARGET(man_${APPLICATION} ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${manpage})
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${manpage} DESTINATION share/man/man1 COMPONENT tools)  
  ENDIF(BUILD_MANPAGES)
ENDFOREACH(APPLICATION ${APPS})

FOREACH(APPLICATION ${CUDA_APPS})
  CUDA_ADD_EXECUTABLE(${APPLICATION} ${APPLICATION}.cxx)
  TARGET_LINK_LIBRARIES(${APPLICATION} cmtkGPU ${CMTK_LIBRARIES} ${CMTK_SYSTEM_LIBRARIES})

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS ${APPLICATION} RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDFOREACH(APPLICATION ${CUDA_APPS})

IF(CMTK_USE_CUDA)
  CUDA_ADD_EXECUTABLE(cudatest cudatest.cxx)

  IF(CMTK_BUILD_WRAPPER)
    INSTALL(TARGETS cudatest RUNTIME DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
  ELSE(CMTK_BUILD_WRAPPER)    
    INSTALL(TARGETS cudatest RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDIF(CMTK_USE_CUDA)

=== contrib/CMakeLists.txt ===
##
##  Copyright 2012, 2013 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4773 $
##
##  $LastChangedDate: 2013-05-29 13:38:14 -0700 (Wed, 29 May 2013) $
##
##  $LastChangedBy: torstenrohlfing $
##

#-----------------------------------------------------------------------------
# Configure third-party contributions.

OPTION(BUILD_CONTRIB_MUNGER "Build, install, and package Greg Jefferis' munger script (requires perl)" OFF)

IF(BUILD_CONTRIB_MUNGER)
  ADD_SUBDIRECTORY(munger)
ENDIF(BUILD_CONTRIB_MUNGER)

=== scripts/CMakeLists.txt ===
##
##  Copyright 2009-2012 SRI International
##
##  Copyright 2012 Torsten Rohlfing
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4638 $
##
##  $LastChangedDate: 2012-11-20 14:15:28 -0800 (Tue, 20 Nov 2012) $
##
##  $LastChangedBy: torstenrohlfing $
##

## Configure scripts for the build tree
SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_BINARY_DIR}/bin)
SET(CMTK_LIBRARY_DIR_CONFIG ${CMAKE_BINARY_DIR}/bin)

SET(SCRIPTS cmtk_functions.sh cmtk_locking.sh cmtk_locking_procmail.sh)
LIST(APPEND SCRIPTS iterative_shape_averaging correct_nex_motion correct_dwi_distortion correct_dwi_distortion_and_motion groupwise_reformat)

FOREACH(s ${SCRIPTS})
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${s}.in ${CMAKE_BINARY_DIR}/bin/${s} @ONLY)
ENDFOREACH(s ${SCRIPTS})

IF(CMTK_BUILD_WRAPPER)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmtk.in ${CMAKE_BINARY_DIR}/bin/cmtk @ONLY)
ENDIF(CMTK_BUILD_WRAPPER)

## Configure SCRIPTS for the install tree
# Link directories.
IF(CMTK_BUILD_WRAPPER)
  SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_LIB_DIR}/bin)
ELSE(CMTK_BUILD_WRAPPER)
  SET(CMTK_BINARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_BIN_DIR})
ENDIF(CMTK_BUILD_WRAPPER)

SET(CMTK_LIBRARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/${CMTK_INSTALL_LIB_DIR})

FOREACH(s ${SCRIPTS})
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/${s}.in ${CMAKE_BINARY_DIR}/Install/${s} @ONLY)
  IF(CMTK_BUILD_WRAPPER)
    INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/Install/${s} DESTINATION ${CMTK_INSTALL_LIB_DIR}/bin COMPONENT tools)
  ELSE(CMTK_BUILD_WRAPPER)
    INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/Install/${s} DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
  ENDIF(CMTK_BUILD_WRAPPER)
ENDFOREACH(s ${SCRIPTS})

IF(CMTK_BUILD_WRAPPER)
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/cmtk.in ${CMAKE_BINARY_DIR}/Install/cmtk @ONLY)
  INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/Install/cmtk DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT tools)
ENDIF(CMTK_BUILD_WRAPPER)

=== Utilities/dcmtk/CMakeLists.txt ===
PROJECT(D4CMTK)

##
##  Copyright 2004-2012 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4596 $
##      
##  $LastChangedDate: 2012-11-12 15:30:14 -0800 (Mon, 12 Nov 2012) $
##
##  $LastChangedBy: torsten_at_home $
##      

SET(DCMTK_PREFIX ${CMAKE_BINARY_DIR})
SET(DCM_DICT_DEFAULT_PATH "/dicom.dic;${DCMTK_PREFIX}/lib/dicom.dic;${CMTK_INSTALL_DATA_DIR}/dicom.dic")

SET(WITH_ZLIB 1)

IF(CMTK_USE_SMP)
  SET(WITH_THREADS 1)
ENDIF(CMTK_USE_SMP)

INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityC.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityCXX.cmake)

CHECK_TYPE_SIZE(int64_t HAVE_INT64_T)
CHECK_TYPE_SIZE(uint64_t HAVE_UINT64_T)

CHECK_INCLUDE_FILE_CXX (sstream HAVE_SSTREAM)
CHECK_INCLUDE_FILE_CXX (strstream HAVE_STRSTREAM)
CHECK_INCLUDE_FILE_CXX (sstream.h HAVE_SSTREAM_H)
CHECK_INCLUDE_FILE_CXX (strstrea.h HAVE_STRSTREA_H)
CHECK_INCLUDE_FILE_CXX (strstream.h HAVE_STRSTREAM_H)
CHECK_INCLUDE_FILE_CXX (alloca.h HAVE_ALLOCA_H)
CHECK_INCLUDE_FILE_CXX (arpa/inet.h HAVE_ARPA_INET_H)
CHECK_INCLUDE_FILE_CXX (assert.h HAVE_ASSERT_H)
CHECK_INCLUDE_FILE_CXX (ctype.h HAVE_CTYPE_H)
CHECK_INCLUDE_FILE_CXX (dirent.h HAVE_DIRENT_H)
CHECK_INCLUDE_FILE_CXX (errno.h HAVE_ERRNO_H)
CHECK_INCLUDE_FILE_CXX (fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILE_CXX (float.h HAVE_FLOAT_H)
CHECK_INCLUDE_FILE_CXX (fnmatch.h HAVE_FNMATCH_H)
CHECK_INCLUDE_FILE_CXX (fstream HAVE_FSTREAM)
CHECK_INCLUDE_FILE_CXX (fstream.h HAVE_FSTREAM_H)
CHECK_INCLUDE_FILE_CXX (grp.h HAVE_GRP_H)
CHECK_INCLUDE_FILE_CXX (ieeefp.h HAVE_IEEEFP_H)
CHECK_INCLUDE_FILE_CXX (inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILE_CXX (iomanip HAVE_IOMANIP)
CHECK_INCLUDE_FILE_CXX (iomanip.h HAVE_IOMANIP_H)
CHECK_INCLUDE_FILE_CXX (iostream HAVE_IOSTREAM)
CHECK_INCLUDE_FILE_CXX (iostream.h HAVE_IOSTREAM_H)
CHECK_INCLUDE_FILE_CXX (io.h HAVE_IO_H)
CHECK_INCLUDE_FILE_CXX (iso646.h HAVE_ISO646_H)
CHECK_INCLUDE_FILE_CXX (libc.h HAVE_LIBC_H)
IF(HAVE_LIBC_H)
  SET(INCLUDE_LIBC_H_AS_CXX 1)
ELSE(HAVE_LIBC_H)
  CHECK_INCLUDE_FILE (libc.h HAVE_LIBC_H)
ENDIF(HAVE_LIBC_H)

CHECK_INCLUDE_FILE_CXX (libpng/png.h HAVE_LIBPNG_PNG_H)
CHECK_INCLUDE_FILE_CXX (limits.h HAVE_LIMITS_H)
CHECK_INCLUDE_FILE_CXX (locale.h HAVE_LOCALE_H)
CHECK_INCLUDE_FILE_CXX (malloc.h HAVE_MALLOC_H)
CHECK_INCLUDE_FILE_CXX (math.h HAVE_MATH_H)
CHECK_INCLUDE_FILE_CXX (memory.h HAVE_MEMORY_H)
CHECK_INCLUDE_FILE_CXX (netdb.h HAVE_NETDB_H)
CHECK_INCLUDE_FILE_CXX (netinet/in.h HAVE_NETINET_IN_H)
CHECK_INCLUDE_FILE_CXX (netinet/in_systm.h HAVE_NETINET_IN_SYSTM_H)
CHECK_INCLUDE_FILE_CXX (netinet/tcp.h HAVE_NETINET_TCP_H)
CHECK_INCLUDE_FILE_CXX (new.h HAVE_NEW_H)
CHECK_INCLUDE_FILE_CXX (pthread.h HAVE_PTHREAD_H)
CHECK_INCLUDE_FILE_CXX (pwd.h HAVE_PWD_H)
CHECK_INCLUDE_FILE_CXX (semaphore.h HAVE_SEMAPHORE_H)
CHECK_INCLUDE_FILE_CXX (setjmp.h HAVE_SETJMP_H)
CHECK_INCLUDE_FILE_CXX (signal.h HAVE_SIGNAL_H)
CHECK_INCLUDE_FILE_CXX (sstream.h HAVE_SSTREAM_H)
CHECK_INCLUDE_FILE_CXX (stat.h HAVE_STAT_H)
CHECK_INCLUDE_FILE_CXX (stdarg.h HAVE_STDARG_H)
CHECK_INCLUDE_FILE_CXX (stdbool.h HAVE_STDBOOL_H)
CHECK_INCLUDE_FILE_CXX (stddef.h HAVE_STDDEF_H)
CHECK_INCLUDE_FILE_CXX (stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILE_CXX (stdio.h HAVE_STDIO_H)
CHECK_INCLUDE_FILE_CXX (stdlib.h HAVE_STDLIB_H)
CHECK_INCLUDE_FILE_CXX (strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILE_CXX (string.h HAVE_STRING_H)
CHECK_INCLUDE_FILE_CXX (synch.h HAVE_SYNCH_H)
CHECK_INCLUDE_FILE_CXX (sys/errno.h HAVE_SYS_ERRNO_H)
CHECK_INCLUDE_FILE_CXX (sys/file.h HAVE_SYS_FILE_H)
CHECK_INCLUDE_FILE_CXX (sys/param.h HAVE_SYS_PARAM_H)
CHECK_INCLUDE_FILE_CXX (sys/resource.h HAVE_SYS_RESOURCE_H)
CHECK_INCLUDE_FILE_CXX (sys/select.h HAVE_SYS_SELECT_H)
CHECK_INCLUDE_FILE_CXX (sys/socket.h HAVE_SYS_SOCKET_H)
CHECK_INCLUDE_FILE_CXX (sys/stat.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILE_CXX (sys/time.h HAVE_SYS_TIME_H)
CHECK_INCLUDE_FILE_CXX (sys/types.h HAVE_SYS_TYPES_H)
CHECK_INCLUDE_FILE_CXX (sys/utime.h HAVE_SYS_UTIME_H)
CHECK_INCLUDE_FILE_CXX (sys/utsname.h HAVE_SYS_UTSNAME_H)
CHECK_INCLUDE_FILE_CXX (sys/wait.h HAVE_SYS_WAIT_H)
CHECK_INCLUDE_FILE_CXX (thread.h HAVE_THREAD_H)
CHECK_INCLUDE_FILE_CXX (time.h HAVE_TIME_H)
CHECK_INCLUDE_FILE_CXX (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILE_CXX (unix.h HAVE_UNIX_H)
CHECK_INCLUDE_FILE_CXX (utime.h HAVE_UTIME_H)
CHECK_INCLUDE_FILE_CXX (wctype.h HAVE_WCTYPE_H)

INCLUDE(CheckFunctionExists)
CHECK_FUNCTION_EXISTS (accept HAVE_ACCEPT)
CHECK_FUNCTION_EXISTS (access HAVE_ACCESS)
CHECK_FUNCTION_EXISTS (bcmp HAVE_BCMP)
CHECK_FUNCTION_EXISTS (bcopy HAVE_BCOPY)
CHECK_FUNCTION_EXISTS (bind HAVE_BIND)
CHECK_FUNCTION_EXISTS (bzero HAVE_BZERO)
CHECK_FUNCTION_EXISTS (connect HAVE_CONNECT)
CHECK_FUNCTION_EXISTS (cuserid HAVE_CUSERID)
CHECK_FUNCTION_EXISTS (finite HAVE_FINITE)
CHECK_FUNCTION_EXISTS (flock HAVE_FLOCK)
CHECK_FUNCTION_EXISTS (fork HAVE_FORK)
CHECK_FUNCTION_EXISTS (getenv HAVE_GETENV)
CHECK_FUNCTION_EXISTS (geteuid HAVE_GETEUID)
CHECK_FUNCTION_EXISTS (getgrnam HAVE_GETGRNAM)
CHECK_FUNCTION_EXISTS (gethostbyname HAVE_GETHOSTBYNAME)
CHECK_FUNCTION_EXISTS (gethostid HAVE_GETHOSTID)
CHECK_FUNCTION_EXISTS (gethostname HAVE_GETHOSTNAME)
CHECK_FUNCTION_EXISTS (getlogin HAVE_GETLOGIN)
CHECK_FUNCTION_EXISTS (getpid HAVE_GETPID)
CHECK_FUNCTION_EXISTS (getpwnam HAVE_GETPWNAM)
CHECK_FUNCTION_EXISTS (getsockname HAVE_GETSOCKNAME)
CHECK_FUNCTION_EXISTS (getsockopt HAVE_GETSOCKOPT)
CHECK_FUNCTION_EXISTS (getuid HAVE_GETUID)
CHECK_FUNCTION_EXISTS (index HAVE_INDEX)
CHECK_FUNCTION_EXISTS (isinf HAVE_ISINF)
CHECK_FUNCTION_EXISTS (isnan HAVE_ISNAN)
CHECK_FUNCTION_EXISTS (itoa HAVE_ITOA)
CHECK_FUNCTION_EXISTS (listen HAVE_LISTEN)
CHECK_FUNCTION_EXISTS (lockf HAVE_LOCKF)
CHECK_FUNCTION_EXISTS (malloc_debug HAVE_MALLOC_DEBUG)
CHECK_FUNCTION_EXISTS (memcmp HAVE_MEMCMP)
CHECK_FUNCTION_EXISTS (memcpy HAVE_MEMCPY)
CHECK_FUNCTION_EXISTS (memmove HAVE_MEMMOVE)
CHECK_FUNCTION_EXISTS (memset HAVE_MEMSET)
CHECK_FUNCTION_EXISTS (mkstemp HAVE_MKSTEMP)
CHECK_FUNCTION_EXISTS (mktemp HAVE_MKTEMP)
CHECK_FUNCTION_EXISTS (rindex HAVE_RINDEX)
CHECK_FUNCTION_EXISTS (select HAVE_SELECT)
CHECK_FUNCTION_EXISTS (setsockopt HAVE_SETSOCKOPT)
CHECK_FUNCTION_EXISTS (setuid HAVE_SETUID)
CHECK_FUNCTION_EXISTS (sleep HAVE_SLEEP)
CHECK_FUNCTION_EXISTS (socket HAVE_SOCKET)
CHECK_FUNCTION_EXISTS (stat HAVE_STAT)
CHECK_FUNCTION_EXISTS (strchr HAVE_STRCHR)
CHECK_FUNCTION_EXISTS (strdup HAVE_STRDUP)
CHECK_FUNCTION_EXISTS (strerror HAVE_STRERROR)
CHECK_FUNCTION_EXISTS (strlcat HAVE_STRLCAT)
CHECK_FUNCTION_EXISTS (strlcpy HAVE_STRLCPY)
CHECK_FUNCTION_EXISTS (strstr HAVE_STRSTR)
CHECK_FUNCTION_EXISTS (strtoul HAVE_STRTOUL)
CHECK_FUNCTION_EXISTS (sysinfo HAVE_SYSINFO)
CHECK_FUNCTION_EXISTS (tempnam HAVE_TEMPNAM)
CHECK_FUNCTION_EXISTS (tmpnam HAVE_TMPNAM)
CHECK_FUNCTION_EXISTS (uname HAVE_UNAME)
CHECK_FUNCTION_EXISTS (usleep HAVE_USLEEP)
CHECK_FUNCTION_EXISTS (vprintf HAVE_VPRINTF)
CHECK_FUNCTION_EXISTS (waitpid HAVE_WAITPID)
CHECK_FUNCTION_EXISTS (_findfirst HAVE__FINDFIRST)

CHECK_FUNCTION_EXISTS(accept HAVE_PROTOTYPE_ACCEPT)
CHECK_FUNCTION_EXISTS(bind HAVE_PROTOTYPE_BIND)
CHECK_FUNCTION_EXISTS(bzero HAVE_PROTOTYPE_BZERO)
CHECK_FUNCTION_EXISTS(connect HAVE_PROTOTYPE_CONNECT)
CHECK_FUNCTION_EXISTS(finite HAVE_PROTOTYPE_FINITE)
CHECK_FUNCTION_EXISTS(flock HAVE_PROTOTYPE_FLOCK)
CHECK_FUNCTION_EXISTS(gethostbyname HAVE_PROTOTYPE_GETHOSTBYNAME)
CHECK_FUNCTION_EXISTS(gethostid HAVE_PROTOTYPE_GETHOSTID)
CHECK_FUNCTION_EXISTS(gethostname HAVE_PROTOTYPE_GETHOSTNAME)
CHECK_FUNCTION_EXISTS(getsockname HAVE_PROTOTYPE_GETSOCKNAME)
CHECK_FUNCTION_EXISTS(getsockopt HAVE_PROTOTYPE_GETSOCKOPT)
CHECK_FUNCTION_EXISTS(gettimeofday HAVE_PROTOTYPE_GETTIMEOFDAY)
CHECK_FUNCTION_EXISTS(isinf HAVE_PROTOTYPE_ISINF)
CHECK_FUNCTION_EXISTS(isnan HAVE_PROTOTYPE_ISNAN)
CHECK_FUNCTION_EXISTS(listen HAVE_PROTOTYPE_LISTEN)
CHECK_FUNCTION_EXISTS(mkstemp HAVE_PROTOTYPE_MKSTEMP)
CHECK_FUNCTION_EXISTS(mktemp HAVE_PROTOTYPE_MKTEMP)
CHECK_FUNCTION_EXISTS(select HAVE_PROTOTYPE_SELECT)
CHECK_FUNCTION_EXISTS(setsockopt HAVE_PROTOTYPE_SETSOCKOPT)
CHECK_FUNCTION_EXISTS(socket HAVE_PROTOTYPE_SOCKET)
CHECK_FUNCTION_EXISTS(std::_vfprintf HAVE_PROTOTYPE_STD__VFPRINTF)
CHECK_FUNCTION_EXISTS(strcasecmp HAVE_PROTOTYPE_STRCASECMP)
CHECK_FUNCTION_EXISTS(stdncasecmp HAVE_PROTOTYPE_STRNCASECMP)
CHECK_FUNCTION_EXISTS(usleep HAVE_PROTOTYPE_USLEEP)
CHECK_FUNCTION_EXISTS(wait3 HAVE_PROTOTYPE_WAIT3)
CHECK_FUNCTION_EXISTS(waitpid HAVE_PROTOTYPE_WAITPID)
CHECK_FUNCTION_EXISTS(_stricmp HAVE_PROTOTYPE__STRICMP)

#Include(CheckLibraryExists)
#CHECK_LIBRARY_EXISTS(iostream HAVE_LIBIOSTREAM)
#CHECK_LIBRARY_EXISTS(nsl HAVE_LIBNSL)
#CHECK_LIBRARY_EXISTS(socket HAVE_LIBSOCKET)

SET(CMAKE_EXTRA_INCLUDE_FILES sys/types.h)
CHECK_TYPE_SIZE("pid_t" SYS_TYPES_PID_T)
CHECK_TYPE_SIZE("size_t" SYS_TYPES_SIZE_T)
CHECK_TYPE_SIZE("ssize_t" SYS_TYPES_SSIZE_T)
CHECK_TYPE_SIZE("uchar" SYS_TYPES_UCHAR)
CHECK_TYPE_SIZE("uint" SYS_TYPES_UINT)
CHECK_TYPE_SIZE("ulong" SYS_TYPES_ULONG)
SET(CMAKE_EXTRA_INCLUDE_FILES) 

Include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS(DIR ndir.h HAVE_NDIR_H)
CHECK_SYMBOL_EXISTS(DIR sys/dir.h HAVE_SYS_DIR_H)
CHECK_SYMBOL_EXISTS(DIR sys/ndir.h HAVE_SYS_NDIR_H)
IF(HAVE_IOSTREAM_H)
  CHECK_SYMBOL_EXISTS(ios::nocreate iostream.h HAVE_IOS_NOCREATE)
ENDIF(HAVE_IOSTREAM_H)

SET(USE_STD_CXX_INCLUDES 1)

SET(HAVE_STD_NAMESPACE ${CMAKE_STD_NAMESPACE})
SET(HAVE_CLASS_TEMPLATE 1)
SET(HAVE_FUNCTION_TEMPLATE 1)
SET(HAVE_EXPLICIT_TEMPLATE_SPECIALIZATION 1)
SET(HAVE_CXX_BOOL 1)

## Copy variables from CMake's internal names to their names in configurable header 
SET(SIZEOF_CHAR ${CMAKE_SIZEOF_CHAR})
SET(SIZEOF_DOUBLE ${CMAKE_SIZEOF_DOUBLE})
SET(SIZEOF_FLOAT ${CMAKE_SIZEOF_FLOAT})
SET(SIZEOF_INT ${CMAKE_SIZEOF_INT})
SET(SIZEOF_LONG ${CMAKE_SIZEOF_LONG})
SET(SIZEOF_SHORT ${CMAKE_SIZEOF_SHORT})
SET(SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})

## Created configured configuration header
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/dcmtk/config/cfunix.h.in ${CMAKE_CURRENT_BINARY_DIR}/cfunix.h @ONLY)

INCLUDE_DIRECTORIES(
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}
	${ZLIB_INCLUDE_DIRS})

INCLUDE_REGULAR_EXPRESSION("^.*.h$")

SET(dcmtk_SRCS
  cmdlnarg.cc
  dcbytstr.cc
  dcchrstr.cc
  dccodec.cc
  dcdatset.cc
  dcdebug.cc
  dcdicdir.cc
  dcdicent.cc
  dcdict.cc
  dcdictzz.cc
  dcdirrec.cc
  dcelem.cc
  dcerror.cc
  dcfilefo.cc
  dchashdi.cc
  dcistrma.cc
  dcistrmf.cc
  dcistrmz.cc
  dcitem.cc
  dclist.cc
  dcmetinf.cc
  dcobject.cc
  dcostrma.cc
  dcostrmf.cc
  dcostrmz.cc
  dcpcache.cc
  dcpixel.cc
  dcpixseq.cc
  dcpxitem.cc
  dcsequen.cc
  dcstack.cc
  dcswap.cc
  dctag.cc
  dctagkey.cc
  dctypes.cc
  dcuid.cc
  dcvm.cc
  dcvr.cc
  dcvrae.cc
  dcvras.cc
  dcvrat.cc
  dcvrcs.cc
  dcvrda.cc
  dcvrds.cc
  dcvrdt.cc
  dcvrfd.cc
  dcvrfl.cc
  dcvris.cc
  dcvrlo.cc
  dcvrlt.cc
  dcvrobow.cc
  dcvrof.cc
  dcvrpn.cc
  dcvrpobw.cc
  dcvrsh.cc
  dcvrsl.cc
  dcvrss.cc
  dcvrst.cc
  dcvrtm.cc
  dcvrui.cc
  dcvrul.cc
  dcvrulup.cc
  dcvrus.cc
  dcvrut.cc
  dcxfer.cc
  didocu.cc
  diutils.cc
  ofcond.cc
  ofconsol.cc
  ofcrc32.cc
  ofdate.cc
  ofdatime.cc
  oflist.cc
  ofstd.cc
  ofstring.cc
  ofthread.cc
  oftime.cc
)

ADD_LIBRARY(D4CMTK ${dcmtk_SRCS})
TARGET_LINK_LIBRARIES(D4CMTK ${ZLIB_LIBRARIES})

=== Utilities/numdiff-5.2.1/CMakeLists.txt ===
##
##  Copyright 2011, 2012 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4444 $
##
##  $LastChangedDate: 2012-07-05 11:46:20 -0700 (Thu, 05 Jul 2012) $
##
##  $LastChangedBy: torstenrohlfing $
##

# ########## Project setup ##########
PROJECT(numdiff-5.2.1)
CMAKE_MINIMUM_REQUIRED(VERSION 2.4.5)

IF(COMMAND cmake_policy)
  cmake_policy(SET CMP0005 OLD) ## explicit escaping of compiler definition strings
ENDIF(COMMAND cmake_policy)

SET(CMAKE_CONFIG_PACKAGE_BUGREPORT "<ivprimi at libero dot it>")
SET(CMAKE_CONFIG_PACKAGE_NAME "Numdiff")
SET(CMAKE_CONFIG_PACKAGE_STRING "Numdiff 5.2")
SET(CMAKE_CONFIG_PACKAGE_TARNAME "numdiff")
SET(CMAKE_CONFIG_PACKAGE_VERSION "5.2")

ADD_DEFINITIONS(-DPACKAGE=\\\"numdiff\\\")

# ######### General setup ##########
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

# ########## numdiff-5.2.1 executable ##########
# Sources:
SET(numdiff_SRCS
  analyze.c arith.c cmpbuf.c cmpfns.c error.c exitfail.c flags.c getopt.c getopt1.c inout.c io.c main.c numutil.c options.c setmode.c side.c util.c xalloc-die.c xmalloc.c)

INCLUDE(FindCygwin)
SET(POSSIBLE_BIN_PATHS ${CYGWIN_INSTALL_PATH}/bin)

FIND_PROGRAM(FIND_EXECUTABLE NAMES find PATHS ${POSSIBLE_BIN_PATHS})

#-----------------------------------------------------------------------------
# Check for system headers.
INCLUDE (CheckIncludeFiles)

CHECK_INCLUDE_FILES(float.h HAVE_FLOAT_H)
CHECK_INCLUDE_FILES(stdarg.h HAVE_STDARG_H)
CHECK_INCLUDE_FILES(stdlib.h HAVE_STDLIB_H)
CHECK_INCLUDE_FILES(string.h HAVE_STRING_H)

# see https://www.gnu.org/s/hello/manual/autoconf/Particular-Headers.html
IF(HAVE_FLOAT_H AND HAVE_STDARG_H AND HAVE_STDLIB_H AND HAVE_STRING_H)
  SET(STDC_HEADERS 1)
  ADD_DEFINITIONS(-DSTDC_HEADERS)
ENDIF(HAVE_FLOAT_H AND HAVE_STDARG_H AND HAVE_STDLIB_H AND HAVE_STRING_H)

CHECK_INCLUDE_FILES(dirent.h HAVE_DIRENT_H)
CHECK_INCLUDE_FILES(stat.h HAVE_STAT_H)
CHECK_INCLUDE_FILES(fcntl.h HAVE_FCNTL_H)
CHECK_INCLUDE_FILES(inttypes.h HAVE_INTTYPES_H)
CHECK_INCLUDE_FILES(locale.h HAVE_LOCALE_H)
CHECK_INCLUDE_FILES(memory.h HAVE_MEMORY_H)
CHECK_INCLUDE_FILES(stdbool.h HAVE_STDBOOL_H)
CHECK_INCLUDE_FILES(stdint.h HAVE_STDINT_H)
CHECK_INCLUDE_FILES(stddef.h HAVE_STDDEF_H)
CHECK_INCLUDE_FILES(strings.h HAVE_STRINGS_H)
CHECK_INCLUDE_FILES(time.h HAVE_TIME_H)
CHECK_INCLUDE_FILES(unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES(vfork.h HAVE_VFORK_H)
CHECK_INCLUDE_FILES(wchar.h HAVE_WCHAR_H)
CHECK_INCLUDE_FILES(wctype.h HAVE_WCTYPE_H)

CHECK_INCLUDE_FILES (sys/dir.h HAVE_SYS_DIR_H)
CHECK_INCLUDE_FILES (sys/file.h HAVE_SYS_FILE_H)
CHECK_INCLUDE_FILES (sys/file.h HAVE_SYS_STAT_H)
CHECK_INCLUDE_FILES (sys/wait.h HAVE_SYS_WAIT_H)

#AC_C_CONST -- obsolete according to https://www.gnu.org/software/hello/manual/autoconf/C-Compiler.html#index-AC_005fC_005fCONST-885
SET(CMAKE_CONFIG_CONST "const")

#AC_C_INLINE
SET(CMAKE_CONFIG_INLINE "${C_INLINE}")

# Check for variable arrays support in C compiler
INCLUDE(CheckCSourceCompiles)
CHECK_C_SOURCE_COMPILES("int main() { int size = 10; char array[size]; }" HAVE_C_VARARRAYS)

# Check for types and substitute replacement types if they don't exist
INCLUDE(CheckTypeSize)

CHECK_TYPE_SIZE(pid_t PID_T_SIZE)
IF(PID_T_SIZE)
  SET(CMAKE_CONFIG_PID_T pid_t)
ELSE(PID_T_SIZE)
  SET(CMAKE_CONFIG_PID_T int)
ENDIF(PID_T_SIZE)

CHECK_TYPE_SIZE(ptrdiff_t PTRDIFF_T_SIZE)
IF(PTRDIFF_T_SIZE)
  SET(CMAKE_CONFIG_PTRDIFF_T ptrdiff_t)
ELSE(PTRDIFF_T_SIZE)
  SET(CMAKE_CONFIG_PTRDIFF_T int)
ENDIF(PTRDIFF_T_SIZE)

CHECK_TYPE_SIZE(ssize_t SSIZE_T_SIZE)
IF(SSIZE_T_SIZE)
  SET(CMAKE_CONFIG_SSIZE_T ssize_t)
ELSE(SSIZE_T_SIZE)
  SET(CMAKE_CONFIG_SSIZE_T int)
ENDIF(SSIZE_T_SIZE)

CHECK_TYPE_SIZE(size_t SIZE_T_SIZE)
IF(SIZE_T_SIZE)
  SET(CMAKE_CONFIG_SIZE_T size_t)
ELSE(SIZE_T_SIZE)
  SET(CMAKE_CONFIG_SIZE_T unsigned int)
ENDIF(SIZE_T_SIZE)

INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/CheckStructMember.cmake)
CHECK_STRUCT_MEMBER("struct stat" st_blksize "sys/stat.h" HAVE_STRUCT_STAT_ST_BLKSIZE)
CHECK_STRUCT_MEMBER("struct stat" st_rdev "sys/stat.h" HAVE_STRUCT_STAT_ST_RDEV)
CHECK_STRUCT_MEMBER("struct stat" st_mtim_nsed "sys/stat.h" HAVE_STRUCT_STAT_ST_MTIM_NSEC)

# --------------------------------------
# Checks for libraries
# --------------------------------------

INCLUDE(CheckLibraryExists)
CHECK_INCLUDE_FILES(gmp.h HAVE_GMP_H)
CHECK_LIBRARY_EXISTS(gmp  __gmpz_init "" HAVE_LIBGMP)

# --------------------------------------
# Checks for library functions
# --------------------------------------

INCLUDE(CheckFunctionExists)
CHECK_FUNCTION_EXISTS(vsprintf HAVE_VSPRINTF)
IF(NOT HAVE_VSPRINTF)
  MESSAGE(FATAL_ERROR "Declaration of vsprintf() not present!")
ENDIF(NOT HAVE_VSPRINTF)

CHECK_FUNCTION_EXISTS(memset HAVE_MEMSET)
IF(NOT HAVE_MEMSET)
  MESSAGE(FATAL_ERROR "Declaration of memset() not present!")
ENDIF(NOT HAVE_MEMSET)

CHECK_FUNCTION_EXISTS(memchr HAVE_MEMCHR)
IF(NOT HAVE_MEMCHR)
  MESSAGE(FATAL_ERROR "Declaration of memchr() not present!")
ENDIF(NOT HAVE_MEMCHR)

CHECK_FUNCTION_EXISTS(strerror HAVE_STRERROR)
IF(NOT HAVE_STRERROR)
  MESSAGE(FATAL_ERROR "Declaration of strerror() not present!")
ENDIF(NOT HAVE_STRERROR)

CHECK_FUNCTION_EXISTS(strspn HAVE_STRSPN)
IF(NOT HAVE_STRSPN)
  MESSAGE(FATAL_ERROR "Declaration of strspn() not present!")
ENDIF(NOT HAVE_STRSPN)

CHECK_FUNCTION_EXISTS(strcspn HAVE_STRCSPN)
IF(NOT HAVE_STRCSPN)
  MESSAGE(FATAL_ERROR "Declaration of strcspn() not present!")
ENDIF(NOT HAVE_STRCSPN)

CHECK_FUNCTION_EXISTS(fork HAVE_FORK)
IF(HAVE_FORK)
  SET(HAVE_WORKING_FORK 1)
  SET(CMAKE_CONFIG_VFORK fork)
ENDIF(HAVE_FORK)

CHECK_FUNCTION_EXISTS(strerror_r HAVE_STRERROR_R)
CHECK_FUNCTION_EXISTS(localeconv HAVE_LOCALECONV)
CHECK_FUNCTION_EXISTS(gettimeofday HAVE_GETTIMEOFDAY)
CHECK_FUNCTION_EXISTS(isascii HAVE_ISASCII)
CHECK_FUNCTION_EXISTS(setlocale HAVE_SETLOCALE)
CHECK_FUNCTION_EXISTS(strchr HAVE_STRCHR)
CHECK_FUNCTION_EXISTS(strftime HAVE_STRFTIME)
CHECK_FUNCTION_EXISTS(waitpid HAVE_WAITPID)

CHECK_INCLUDE_FILES (alloca.h HAVE_ALLOCA_H)
CHECK_FUNCTION_EXISTS(alloca HAVE_ALLOCA)

CHECK_FUNCTION_EXISTS(bcopy HAVE_BCOPY)
CHECK_FUNCTION_EXISTS(btowc HAVE_BTOWC)
CHECK_FUNCTION_EXISTS(bzero HAVE_BZERO)
CHECK_FUNCTION_EXISTS(clock_gettime HAVE_CLOCK_GETTIME)

# setmode DOS ?
##AC_FUNC_SETMODE_DOS

## Check for clock_gettime and its library.  Solaris puts it in -lrt or
## -lposix4, but we don't want to link that library unless we have to.
#diff_saved_libs=$LIBS
#AC_SEARCH_LIBS(clock_gettime, [rt posix4])
#case $ac_cv_search_clock_gettime in
#no | 'none required')
#  LIB_CLOCK_GETTIME=;;
#*)
#  LIB_CLOCK_GETTIME=$ac_cv_search_clock_gettime;;
#esac
#AC_SUBST([LIB_CLOCK_GETTIME])


OPTION(NUMDIFF_USE_UNLOCKED_IO "Define if you want getc etc. to use unlocked I/O if available. Unlocked I/O can improve performance in unithreaded apps, but it is not safe for multithreaded apps." ON )

CHECK_FUNCTION_EXISTS(clearerr_unlocked HAVE_DECL_CLEARERR_UNLOCKED)
CHECK_FUNCTION_EXISTS(feof_unlocked HAVE_DECL_FEOF_UNLOCKED)
CHECK_FUNCTION_EXISTS(ferror_unlocked HAVE_DECL_FERROR_UNLOCKED)
CHECK_FUNCTION_EXISTS(fflush_unlocked HAVE_DECL_FFLUSH_UNLOCKED)
CHECK_FUNCTION_EXISTS(fgets_unlocked HAVE_DECL_FGETS_UNLOCKED)
CHECK_FUNCTION_EXISTS(fputc_unlocked HAVE_DECL_FPUTC_UNLOCKED)
CHECK_FUNCTION_EXISTS(fputs_unlocked HAVE_DECL_FPUTS_UNLOCKED)
CHECK_FUNCTION_EXISTS(fread_unlocked HAVE_DECL_FREAD_UNLOCKED)
CHECK_FUNCTION_EXISTS(fwrite_unlocked HAVE_DECL_FWRITE_UNLOCKED)
CHECK_FUNCTION_EXISTS(getc_unlocked HAVE_DECL_GETC_UNLOCKED)
CHECK_FUNCTION_EXISTS(getchar_unlocked HAVE_DECL_GETCHAR_UNLOCKED)
CHECK_FUNCTION_EXISTS(putc_unlocked HAVE_DECL_PUTC_UNLOCKED)
CHECK_FUNCTION_EXISTS(putchar_unlocked HAVE_DECL_PUTCHAR_UNLOCKED)
CHECK_FUNCTION_EXISTS(strerror HAVE_DECL_STRERROR)

##
## Find libintl/gettext and configure NLS if available
##
INCLUDE(${CMAKE_CURRENT_SOURCE_DIR}/CMake/FindLibintlGettext.cmake)
IF(GETTEXT_FOUND)
  OPTION(NUMDIFF_USE_NLS "Turn on Natural Language Support" ON)

  IF(NUMDIFF_USE_NLS)
    ADD_DEFINITIONS(-DENABLE_NLS)
  ENDIF(NUMDIFF_USE_NLS)
  
ENDIF(GETTEXT_FOUND)

##
## Configure GMP support
##
IF(HAVE_GMP_H AND HAVE_LIBGMP)
  OPTION(NUMDIFF_USE_GMP "Turn on use of GNU MP" ON)
  IF(NUMDIFF_USE_GMP)
    FIND_LIBRARY(LIBGMP_LIBRARY gmp)
  ELSE(NUMDIFF_USE_GMP)
    ADD_DEFINITIONS(-DDISABLE_GMP)
  ENDIF(NUMDIFF_USE_GMP)
ELSE(HAVE_GMP_H AND HAVE_LIBGMP)
  ADD_DEFINITIONS(-DDISABLE_GMP)
ENDIF(HAVE_GMP_H AND HAVE_LIBGMP)

CONFIGURE_FILE(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)
ADD_DEFINITIONS(-DHAVE_CONFIG_H)

# actual target:
ADD_EXECUTABLE(numdiff ${numdiff_SRCS})
TARGET_LINK_LIBRARIES(numdiff ${LIBGMP_LIBRARY} ${GETTEXT_LIBRARIES})

# add install target:
#INSTALL(TARGETS numdiff DESTINATION bin)

=== Utilities/sqlite3/CMakeLists.txt ===
##
##  Copyright 2010 Torsten Rohlfing
##
##  Copyright 2010-2011 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 199 $
##      
##  $LastChangedDate: 2009-07-13 16:38:02 -0700 (Mon, 13 Jul 2009) $
##
##  $LastChangedBy: torstenrohlfing $
##      

PROJECT(sqlite3)
INCLUDE_REGULAR_EXPRESSION("^.*.h$")

SET(SQLITE_VERSION_MAJOR 3)
SET(SQLITE_VERSION_MINOR 7)
SET(SQLITE_VERSION_PATCH 4)
SET(SQLITE_VERSION "sqlite-3.7.4")

SET(sqlite_SRCS sqlite3.c)

ADD_DEFINITIONS(-DSQLITE_THREADSAFE=0 -DSQLITE_OMIT_LOAD_EXTENSION -DSQLITE_ENABLE_FTS3 -DSQLITE_ENABLE_RTREE)

ADD_LIBRARY(cmtksqlite3 ${sqlite_SRCS})
TARGET_LINK_LIBRARIES(cmtksqlite3)

INSTALL(TARGETS cmtksqlite3
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${files} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR} COMPONENT headers)

ADD_EXECUTABLE(sqlite shell.c)
TARGET_LINK_LIBRARIES(sqlite cmtksqlite3)
INSTALL(TARGETS sqlite
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

SET(SQLITE_LIBRARIES cmtksqlite3)

=== Utilities/zlib/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.4)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS ON)

project(cmtkZlib C)

include(CheckTypeSize)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
enable_testing()

check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(stdint.h    HAVE_STDINT_H)
check_include_file(stddef.h    HAVE_STDDEF_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1)
# We add these other definitions here because CheckTypeSize.cmake
# in CMake 2.4.x does not automatically do so and we want
# compatibility with CMake 2.4.x.
if(HAVE_SYS_TYPES_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_SYS_TYPES_H)
endif()
if(HAVE_STDINT_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDINT_H)
endif()
if(HAVE_STDDEF_H)
    list(APPEND CMAKE_REQUIRED_DEFINITIONS -DHAVE_STDDEF_H)
endif()
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)
   add_definitions(-D_LARGEFILE64_SOURCE=1)
endif()
set(CMAKE_REQUIRED_DEFINITIONS) # clear variable

#
# Check for fseeko
#
check_function_exists(fseeko HAVE_FSEEKO)
if(NOT HAVE_FSEEKO)
    add_definitions(-DNO_FSEEKO)
endif()

#
# Check for unistd.h
#
check_include_file(unistd.h Z_HAVE_UNISTD_H)

if(MSVC)
    set(CMAKE_DEBUG_POSTFIX "d")
    add_definitions(-D_CRT_SECURE_NO_DEPRECATE)
    add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
endif()

if(NOT CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_CURRENT_BINARY_DIR)
    # If we're doing an out of source build and the user has a zconf.h
    # in their source tree...
    if(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h)
        message(FATAL_ERROR
            "You must remove ${CMAKE_CURRENT_SOURCE_DIR}/zconf.h "
            "from the source tree.  This file is included with zlib "
            "but CMake generates this file for you automatically "
            "in the build directory.")
  endif()
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/zconf.h.cmakein
               ${CMAKE_CURRENT_BINARY_DIR}/zconf.h @ONLY)


#============================================================================
# zlib
#============================================================================

set(ZLIB_PUBLIC_HDRS
    ${CMAKE_CURRENT_BINARY_DIR}/zconf.h
    zlib.h
    cmtk_zlib_mangle.h
)
set(ZLIB_PRIVATE_HDRS
    crc32.h
    deflate.h
    gzguts.h
    inffast.h
    inffixed.h
    inflate.h
    inftrees.h
    trees.h
    zutil.h
)
set(ZLIB_SRCS
    adler32.c
    compress.c
    crc32.c
    deflate.c
    gzclose.c
    gzlib.c
    gzread.c
    gzwrite.c
    inflate.c
    infback.c
    inftrees.c
    inffast.c
    trees.c
    uncompr.c
    zutil.c
)

include_directories( 
  BEFORE
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  )

# parse the full version number from zlib.h and include in ZLIB_FULL_VERSION
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/zlib.h _zlib_h_contents)
string(REGEX REPLACE ".*#define[ \t]+ZLIB_VERSION[ \t]+\"([0-9A-Za-z.]+)\".*"
    "\\1" ZLIB_FULL_VERSION ${_zlib_h_contents})

add_library(cmtkZlib ${ZLIB_SRCS} ${ZLIB_PUBLIC_HDRS} ${ZLIB_PRIVATE_HDRS})
set_target_properties(cmtkZlib PROPERTIES DEFINE_SYMBOL ZLIB_DLL)

set_target_properties(cmtkZlib PROPERTIES SOVERSION 1)

if(NOT CYGWIN)
    # This property causes shared libraries on Linux to have the full version
    # encoded into their final filename.  We disable this on Cygwin because
    # it causes cygz-${ZLIB_FULL_VERSION}.dll to be created when cygz.dll
    # seems to be the default.
    #
    # This has no effect with MSVC, on that platform the version info for
    # the DLL comes from the resource file win32/zlib1.rc
    set_target_properties(cmtkZlib PROPERTIES VERSION ${ZLIB_FULL_VERSION})
endif()

if(NOT SKIP_INSTALL_LIBRARIES AND NOT SKIP_INSTALL_ALL )
    install(TARGETS cmtkZlib
      RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
      LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
      ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)
endif()
if(NOT SKIP_INSTALL_HEADERS AND NOT SKIP_INSTALL_ALL )
    install(FILES ${ZLIB_PUBLIC_HDRS} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR} COMPONENT headers)
endif()

=== libs/Base/CMakeLists.txt ===
##
##  Copyright 1997-2010 Torsten Rohlfing
##
##  Copyright 2004-2013 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 5044 $
##
##  $LastChangedDate: 2013-11-27 13:19:12 -0800 (Wed, 27 Nov 2013) $
##
##  $LastChangedBy: torsten_at_home $
##

# Sources of non-templated classes.
SET(cmtkBase_SRCS
  cmtkActiveDeformationModel.cxx
  cmtkActiveShapeModel.cxx
  cmtkAffineXform.cxx
  cmtkAffineXformUniformVolume.cxx
  cmtkAnatomicalOrientation.cxx
  cmtkAnatomicalOrientationBase.cxx
  cmtkAnatomicalOrientationPermutationMatrix.cxx
  cmtkBitVector.cxx
  cmtkCompatibilityMatrix4x4.cxx
  cmtkDataGrid.cxx
  cmtkDataGrid_Crop.cxx
  cmtkDataGridFilter.cxx
  cmtkDataGridConnectedComponents.cxx
  cmtkDataGridLocalCorrelation.cxx
  cmtkDataGridMorphologicalOperators.cxx
  cmtkDeformationField.cxx
  cmtkDeformationField_Jacobian.cxx
  cmtkDirectionSet.cxx
  cmtkFilterVolume.cxx
  cmtkFitAffineToLandmarks.cxx
  cmtkFitAffineToWarpXform.cxx
  cmtkFitAffineToXformList.cxx
  cmtkFitRigidToLandmarks.cxx
  cmtkFitSplineWarpToDeformationField.cxx
  cmtkFitSplineWarpToLandmarks.cxx
  cmtkFitSplineWarpToXformList.cxx
  cmtkFitToXformListBase.cxx
  cmtkFunctional.cxx
  cmtkGeneralLinearModel.cxx
  cmtkHistogram.cxx
  cmtkHypothesisTests.cxx
  cmtkImageOperation.cxx
  cmtkImageOperationCropRegion.cxx
  cmtkImageOperationCropThreshold.cxx
  cmtkImageOperationDistanceMap.cxx
  cmtkImageOperationDownsample.cxx
  cmtkImageOperationHistogramEqualization.cxx
  cmtkImageOperationMapValues.cxx
  cmtkImageOperationRegionFilter.cxx
  cmtkImageOperationResampleIsotropic.cxx
  cmtkImageOperationScaleToRange.cxx
  cmtkImageOperationThreshold.cxx
  cmtkImageOperationOtsuThreshold.cxx
  cmtkImageOperationPruneHistogram.cxx
  cmtkImageOperationRevert.cxx
  cmtkJointHistogram.cxx
  cmtkJointHistogramBase.cxx
  cmtkLandmark.cxx
  cmtkLandmarkPair.cxx
  cmtkLandmarkList.cxx
  cmtkLandmarkPairList.cxx
  cmtkMagphanEMR051.cxx
  cmtkMagphanEMR051_GetPhantomImage.cxx
  cmtkMathFunctionWrappers.cxx
  cmtkMathUtil_LinAlg.cxx
  cmtkMathUtil_Random.cxx
  cmtkMathUtil_Statistics.cxx
  cmtkMatrix3x3.cxx
  cmtkMatrix4x4.cxx
  cmtkMetaInformationObject.cxx
  cmtkParametricPlane.cxx
  cmtkScalarImage.cxx
  cmtkScalarImageGradientField.cxx
  cmtkSegmentationLabel.cxx
  cmtkSplineWarpXform.cxx
  cmtkSplineWarpXform_Inverse.cxx
  cmtkSplineWarpXform_Jacobian.cxx
  cmtkSplineWarpXform_Rigidity.cxx
  cmtkSplineWarpXformUniformVolume.cxx
  cmtkTransformChangeToSpaceAffine.cxx
  cmtkTransformChangeFromSpaceAffine.cxx
  cmtkTransformedVolumeAxes.cxx
  cmtkTypedArray.cxx
  cmtkTypedArray_Statistics.cxx
  cmtkTypedArrayFunctionHistogramMatching.cxx
  cmtkTypedArrayFunctionHistogramEqualization.cxx
  cmtkTypedArrayNoiseEstimatorNaiveGaussian.cxx
  cmtkTypes.cxx
  cmtkUniformDistanceMap.cxx
  cmtkUniformVolume.cxx
  cmtkUniformVolume_Crop.cxx
  cmtkUniformVolume_Differential.cxx
  cmtkUniformVolume_Resample.cxx
  cmtkUniformVolume_Space.cxx
  cmtkUniformVolumeGaussianFilter.cxx
  cmtkUniformVolumeLaplaceFilter.cxx
  cmtkUniformVolumeInterpolatorBase.cxx
  cmtkUniformVolumeInterpolatorPartialVolume.cxx
  cmtkUniformVolumeMorphologicalOperators.cxx
  cmtkUniformVolumePainter.cxx
  cmtkVolumeClipping.cxx
  cmtkVolume.cxx
  cmtkVolumeGridToGridLookup.cxx
  cmtkWarpXform.cxx
  cmtkXform.cxx
  cmtkXformList.cxx
  cmtkXformListEntry.cxx
)

ADD_LIBRARY(cmtkBase ${cmtkBase_SRCS})

TARGET_LINK_LIBRARIES(cmtkBase cmtkSystem cmtkNumerics )

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkBase PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkBase
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx}  DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/Base/ COMPONENT headers)

=== libs/IO/CMakeLists.txt ===
##
##  Copyright 2004-2012 SRI International
##
##  Copyright 1997-2009 Torsten Rohlfing
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 5014 $
##
##  $LastChangedDate: 2013-11-15 16:24:20 -0800 (Fri, 15 Nov 2013) $
##
##  $LastChangedBy: torstenrohlfing $
##

# Sources of non-templated classes.
SET(cmtkIO_SRCS
  cmtkAffineXformITKIO.cxx
  cmtkSplineWarpXformITKIO.cxx
  cmtkClassStreamAffineXform.cxx
  cmtkClassStreamParametricPlane.cxx
  cmtkClassStreamStudyList.cxx
  cmtkClassStreamWarpXform.cxx
  cmtkFileFormat.cxx
  cmtkGroupwiseRegistrationFunctionalIO.cxx
  cmtkImageFileDICOM.cxx
  cmtkImageOperationApplyMask.cxx
  cmtkImageStackDICOM.cxx
  cmtkLandmarkIO.cxx
  cmtkLandmarkListIO.cxx
  cmtkPhantomIO_MagphanEMR051.cxx
  cmtkSegmentationLabelIO.cxx
  cmtkSiemensCSAHeader.cxx
  cmtkStudy.cxx
  cmtkStudyList.cxx
  cmtkTypedStream.cxx
  cmtkTypedStreamInput.cxx
  cmtkTypedStreamOutput.cxx
  cmtkTypedStreamStudylist.cxx
  cmtkVolumeFromFile.cxx
  cmtkVolumeFromFileAnalyze.cxx
  cmtkVolumeFromFileBioRad.cxx
  cmtkVolumeFromFileMetaFile.cxx
  cmtkVolumeFromFileNRRD.cxx
  cmtkVolumeFromFileNifti.cxx
  cmtkVolumeFromFileVanderbilt.cxx
  cmtkVolumeFromSlices.cxx
  cmtkVolumeIO.cxx
  cmtkXformIO.cxx
  cmtkXformListIO.cxx
  cmtkXformIONrrd.cxx
  nifti1_io_math.c
)

IF(CMTK_USE_DCMTK)
  SET(cmtkIO_SRCS ${cmtkIO_SRCS} 
    cmtkDICOM.cxx
    cmtkVolumeFromStudy.cxx
    cmtkVolumeFromFileDICOM.cxx)
ENDIF(CMTK_USE_DCMTK)

IF(CMTK_USE_SQLITE)
  SET(cmtkIO_SRCS ${cmtkIO_SRCS} 
    cmtkSQLite.cxx)
ENDIF(CMTK_USE_SQLITE)

ADD_LIBRARY(cmtkIO ${cmtkIO_SRCS})

TARGET_LINK_LIBRARIES(cmtkIO cmtkBase cmtkSystem cmtkNumerics ${NRRD_LIBRARIES} ${CMTK_SQLITE_LIB} ${DCMTK_LIBRARIES} ${CMTK_ZLIB_LIB})

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkIO PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkIO
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/IO COMPONENT headers)

=== libs/System/CMakeLists.txt ===
##
##  Copyright 1997-2010 Torsten Rohlfing
##
##  Copyright 2004-2013 SRI International
##
##  This file is part of the Computational Morphometry Toolkit.
##
##  http://www.nitrc.org/projects/cmtk/
##
##  The Computational Morphometry Toolkit is free software: you can
##  redistribute it and/or modify it under the terms of the GNU General Public
##  License as published by the Free Software Foundation, either version 3 of
##  the License, or (at your option) any later version.
##
##  The Computational Morphometry Toolkit is distributed in the hope that it
##  will be useful, but WITHOUT ANY WARRANTY; without even the implied
##  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License along
##  with the Computational Morphometry Toolkit.  If not, see
##  <http://www.gnu.org/licenses/>.
##
##  $Revision: 4672 $
##
##  $LastChangedDate: 2013-01-10 15:36:19 -0800 (Thu, 10 Jan 2013) $
##
##  $LastChangedBy: torstenrohlfing $
##

# Sources of non-templated classes.
SET(cmtkSystem_SRCS
  cmtkCommandLine.cxx
  cmtkCommandLineCallback.cxx
  cmtkCommandLineItem.cxx
  cmtkCommandLineKeyToAction.cxx
  cmtkCommandLineKeyToActionEnum.cxx
  cmtkCommandLineKeyToActionSingle.cxx
  cmtkCommandLineNonOptionParameter.cxx
  cmtkCommandLineNonOptionParameterVector.cxx
  cmtkCommandLineHelp.cxx
  cmtkCommandLineMan.cxx
  cmtkCommandLineXML.cxx
  cmtkCommandLineWiki.cxx
  cmtkCompressedStream.cxx
  cmtkCompressedStreamFile.cxx
  cmtkCompressedStreamPipe.cxx
  cmtkCompressedStreamReaderBase.cxx
  cmtkCompressedStreamZlib.cxx
  cmtkConsole.cxx
  cmtkFileUtils.cxx
  cmtkMemory.cxx
  cmtkMountPoints.cxx
  cmtkProgress.cxx	
  cmtkProgressConsole.cxx
  cmtkRegressionTracker.cxx
  cmtkStackBacktrace
  cmtkStrUtility.cxx
  cmtkThreads.cxx
  cmtkThreadPoolThreads.cxx
  cmtkThreadSemaphore.cxx
  cmtkTimers.cxx
)

IF(CMTK_USE_BZIP2)
  LIST(APPEND cmtkSystem_SRCS cmtkCompressedStreamBZip2.cxx)
ENDIF(CMTK_USE_BZIP2)

IF(CMTK_USE_LZMA)
  LIST(APPEND cmtkSystem_SRCS cmtkCompressedStreamLZMA.cxx)
ENDIF(CMTK_USE_LZMA)

IF(CMTK_USE_GCD)
  LIST(APPEND cmtkSystem_SRCS cmtkSafeCounterGCD.cxx cmtkThreadPoolGCD.cxx)
ENDIF(CMTK_USE_GCD)

ADD_LIBRARY(cmtkSystem ${cmtkSystem_SRCS})

SET(cmtkSystem_LIBS ${CMTK_BZIP2_LIBS} ${CMTK_LZMA_LIBS} ${CMTK_ZLIB_LIB} ${ZLIB_LIBRARIES} ${MXML_LIBRARIES})
IF(CMTK_USE_FFTW_FOUND)
  LIST(APPEND cmtkSystem_LIBS ${CMTK_FFTW_LIBRARIES})
ENDIF(CMTK_USE_FFTW_FOUND)

TARGET_LINK_LIBRARIES(cmtkSystem ${cmtkSystem_LIBS})

IF(CMTK_LIBRARY_PROPERTIES)
  SET_TARGET_PROPERTIES(cmtkSystem PROPERTIES ${CMTK_LIBRARY_PROPERTIES})
ENDIF(CMTK_LIBRARY_PROPERTIES)

INSTALL(TARGETS cmtkSystem
  RUNTIME DESTINATION ${CMTK_INSTALL_BIN_DIR} COMPONENT runtime
  LIBRARY DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT runtime
  ARCHIVE DESTINATION ${CMTK_INSTALL_LIB_DIR} COMPONENT libraries)

FILE(GLOB files_h "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
FILE(GLOB files_txx "${CMAKE_CURRENT_SOURCE_DIR}/*.txx")
INSTALL(FILES ${files_h} ${files_txx} DESTINATION ${CMTK_INSTALL_INCLUDE_DIR}/System COMPONENT headers)

=== debian/changelog ===
cmtk (3.0.0-1ubuntu1) trusty; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - debian/control: Use libtiff-dev instead of libtiff4-dev build-dependency.
  * Drop cmake2.8.10-compat.patch, as it is no longer necessary.

 -- Logan Rosen <logan@ubuntu.com>  Tue, 14 Jan 2014 23:29:16 -0500

cmtk (3.0.0-1) unstable; urgency=low

  * New major upstream bugfix release - see README and changelog
    for details:
    - affine transformation matrices (were broken when shear and
      non-isotropic scale were used)
    - handling of NIfTI qform and sform has changed
    - fit_spline_xform, xform2scalar etc. might produce different
      output now
    - should be compatible with cmake 2.8.10 (Closes: #697410)

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 10 Jan 2014 09:34:59 -0500

cmtk (2.2.6-1ubuntu2) trusty; urgency=low

  * Use libtiff-dev instead of libtiff4-dev build-dependency.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Thu, 05 Dec 2013 22:48:25 +0000

cmtk (2.2.6-1ubuntu1) raring; urgency=low

  * cmake2.8.10-compat.patch: fix ftbfs due to new cmake

 -- Julian Taylor <jtaylor@ubuntu.com>  Sun, 06 Jan 2013 02:42:11 +0100

=== debian/control ===
Source: cmtk
Section: science
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50~),
               cmake,
               libmxml-dev,
               libsqlite3-dev,
               zlib1g-dev | libz-dev,
               libdcmtk2-dev | libdcmtk1-dev | libdcmtk-dev,
               libbz2-dev,
               libfftw3-dev,
               liblzma-dev,
               libqt4-dev, qt4-qmake,
               libpng-dev,
               libtiff-dev,
               libwrap0-dev,
               libcharls-dev | libdcmtk1-dev | libdcmtk2-dev (<< 3.6.0-8~),
               libxml2-dev,
               libssl-dev,
               xvfb,
               xauth,
Standards-Version: 3.9.3
Homepage: http://www.nitrc.org/projects/cmtk/
Vcs-Git: git://git.debian.org/pkg-exppsy/cmtk.git
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/cmtk.git;a=summary


Package: cmtk
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: sri24-atlas
Suggests: numdiff
Description: Computational Morphometry Toolkit
 A software toolkit for computational morphometry of biomedical
 images, CMTK comprises a set of command line tools and a back-end
 general-purpose library for processing and I/O.
 .
 The command line tools primarily provide the following functionality:
 registration (affine and nonrigid; single and multi-channel; pairwise
 and groupwise), image correction (MR bias field estimation;
 interleaved image artifact correction), processing (filters;
 combination of segmentations via voting and STAPLE; shape-based
 averaging), statistics (t-tests; general linear regression).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DISTDIR=$(CURDIR)/debian/cmtk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# custom option tests to provide build for validating unittests
ifneq (,$(findstring docheck,$(DEB_BUILD_OPTIONS)))
	TESTING=ON
	DEB_HOST_ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)
 ifeq ($(DEB_HOST_ARCH),i386)
	TFLAGS=-march=pentium4
 endif
 ifeq ($(DEB_HOST_ARCH),amd64)
	TFLAGS=-march=nocona
 endif
    TFLAGS+=-mmmx -msse -msse2 -mfpmath=sse
	OPT_CMAKE_FLAGS=-DCMAKE_C_FLAGS:STRING="$(TFLAGS)" \
					-DCMAKE_ANSI_CXXFLAGS:STRING="$(TFLAGS)"
else
	TESTING=OFF
	export DEB_BUILD_OPTIONS += " nocheck"
endif

%:
	dh $@ --parallel


override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
		-DBUILD_APPS:BOOL=ON \
		-DBUILD_DOCUMENTATION:BOOL=OFF \
		-DBUILD_GUI:BOOL=ON \
		-DBUILD_SHARED_LIBS:BOOL=ON \
		-DBUILD_TESTING:BOOL=$(TESTING) \
		-DCMTK_BUILD_DCMTK:BOOL=OFF \
		-DCMTK_BUILD_MXML:BOOL=OFF \
		-DCMTK_BUILD_NRRD:BOOL=ON \
		-DCMTK_BUILD_SQLITE:BOOL=OFF \
		-DCMTK_BUILD_ZLIB:BOOL=OFF \
		-DCMTK_ROOT_PATH_SRI24:PATH=/usr/share/data/sri24-atlas \
		-DCMTK_USE_DCMTK:BOOL=ON \
		-DCMTK_USE_FFTW:BOOL=ON \
		-DCMTK_USE_QT:BOOL=ON \
		-DCMTK_USE_SMP:BOOL=ON \
		-DCMTK_USE_SQLITE:BOOL=ON \
		-DDART_TESTING_TIMEOUT:STRING=15000 \
		-DMXML_INCLUDE_DIR:PATH=/usr/include \
		-DLZMA_INCLUDE_DIRS:PATH=/usr/include/lzma \
		-DCMAKE_SKIP_RPATH:BOOL=OFF \
		-DCMTK_BUILD_WRAPPER:BOOL=ON \
		$(OPT_CMAKE_FLAGS)

override_dh_auto_test:
ifneq (,$(findstring docheck,$(DEB_BUILD_OPTIONS)))
	xvfb-run --auto-servernum --server-num=20 \
		dh_auto_test
endif

override_dh_auto_install:
	dh_auto_install

	: # Remove not needed headers, cmake files etc
	rm -fr $(DISTDIR)/usr/include
	-/usr/bin/find $(DISTDIR) -iname *.cmake -delete

	: # Prune duplicate docs
	rm -fr $(DISTDIR)/usr/share/cmtk/doc

	: # Generate manpages
	xvfb-run --auto-servernum --server-num=20 \
		scripts/gen_manpages \
	|| dpkg -l xvfb | awk '/xvfb/{print $3;}' | grep -q ubuntu
	: # Above condition just to ignore unclean exit from xvfb on elderly broken ubuntus
	: # Cleaner solution patches are welcome!

override_dh_installman:
	dh_installman debian/manpages/*

override_dh_auto_clean:
	dh_auto_clean
	rm -rf debian/manpages

get-orig-source:
	uscan --verbose --rename --force-download

get-orig-source-svn:
	cd ../cmtk.gitsvn && \
	git svn rebase && \
	rev=$$(git show | sed -n -e '/git-svn-id/s/.*@\([0-9]*\) .*/\1/gp') && \
	otgz=cmtk-2.1.0~svn$$rev.tar.gz && \
	sh scripts/make_src_archive.sh && \
	mv CMTK-2.1.0svn-Source.tar.gz $$otgz && \
	cd - && \
	git-import-orig ../cmtk.gitsvn/$$otgz || \
	echo "Failed to git-import-orig ../cmtk.gitsvn/$$otgz"
